Index: branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs
===================================================================
--- branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs	(revision 7323)
+++ branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs	(revision 7325)
@@ -271,4 +271,5 @@
       generationsReducer.TargetParameterName.Value = new StringValue("Generations");
       generationsReducer.ReductionOperation.Value = new ReductionType(ReductionTypes.Min);
+      generationsReducer.TargetOperation.Value = new TargetOperationType(TargetOperationTypes.Sum);
 
       evaluatedSolutionsReducer.Name = "Increment Evaluated Solutions";
@@ -276,4 +277,5 @@
       evaluatedSolutionsReducer.TargetParameterName.Value = new StringValue(EvaluatedSolutionsParameter.Name);
       evaluatedSolutionsReducer.ReductionOperation.Value = new ReductionType(ReductionTypes.Sum);
+      evaluatedSolutionsReducer.TargetOperation.Value = new TargetOperationType(TargetOperationTypes.Sum);
 
       emigrantsSelector.Name = "Emigrants Selector (placeholder)";
Index: branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 7323)
+++ branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 7325)
@@ -118,4 +118,6 @@
     <Compile Include="Assigner.cs" />
     <Compile Include="AlgorithmOperator.cs" />
+    <Compile Include="TargetOperationType.cs" />
+    <Compile Include="TargetOperationTypes.cs" />
     <Compile Include="IntDataReducer.cs" />
     <Compile Include="ReductionType.cs" />
Index: branches/HiveHiveEngine/HeuristicLab.Operators/3.3/IntDataReducer.cs
===================================================================
--- branches/HiveHiveEngine/HeuristicLab.Operators/3.3/IntDataReducer.cs	(revision 7323)
+++ branches/HiveHiveEngine/HeuristicLab.Operators/3.3/IntDataReducer.cs	(revision 7325)
@@ -32,4 +32,5 @@
   [StorableClass]
   public sealed class IntDataReducer : SingleSuccessorOperator {
+    #region Parameter Properties
     public ScopeTreeLookupParameter<IntValue> ParameterToReduce {
       get { return (ScopeTreeLookupParameter<IntValue>)Parameters["ParameterToReduce"]; }
@@ -44,4 +45,8 @@
       get { return (ValueParameter<ReductionType>)Parameters["ReductionOperation"]; }
     }
+    public ValueParameter<TargetOperationType> TargetOperation {
+      get { return (ValueParameter<TargetOperationType>)Parameters["TargetOperation"]; }
+    }
+    #endregion
 
     [StorableConstructor]
@@ -52,8 +57,11 @@
     public IntDataReducer()
       : base() {
-      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("ParameterToReduce", "The actual parameter defined by TargetParameterName."));
-      Parameters.Add(new ValueLookupParameter<StringValue>("TargetParameterName", "Parameter name to add the value to.", new StringValue(string.Empty)));
+      #region Create parameters
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("ParameterToReduce", "The parameter on which the reduction operation should be applied."));
+      Parameters.Add(new ValueLookupParameter<StringValue>("TargetParameterName", "Parameter to store the result in.", new StringValue(string.Empty)));
       Parameters.Add(new LookupParameter<IntValue>("TargetParameter", "The actual parameter defined by TargetParameterName."));
       Parameters.Add(new ValueParameter<ReductionType>("ReductionOperation", "The reduction operation to perform."));
+      Parameters.Add(new ValueParameter<TargetOperationType>("TargetOperation", "The target operation to perform."));
+      #endregion
     }
 
@@ -69,5 +77,5 @@
         if (TargetParameter.ActualValue == null) TargetParameter.ActualValue = new IntValue();
 
-        int result;
+        int result = 1;
         switch (ReductionOperation.Value.Value) {
           case ReductionTypes.Sum:
@@ -75,5 +83,4 @@
             break;
           case ReductionTypes.Prod:
-            result = 1;
             intValues.ForEach(x => result *= x.Value);
             break;
@@ -87,9 +94,18 @@
             result = intValues.Max(x => x.Value);
             break;
-          default:
-            throw new ArgumentException("Unknown ReductionType: " + ReductionOperation.Value.Value);
         }
-        //TODO: there should be at least a Set, Add and Mul operation
-        TargetParameter.ActualValue.Value += result;
+
+        switch (TargetOperation.Value.Value) {
+          case TargetOperationTypes.Set:
+            TargetParameter.ActualValue.Value = result;
+            break;
+          case TargetOperationTypes.Sum:
+            TargetParameter.ActualValue.Value += result;
+            break;
+          case TargetOperationTypes.Prod:
+            if (TargetParameter.ActualValue.Value == 0) TargetParameter.ActualValue.Value = 1;
+            TargetParameter.ActualValue.Value *= result;
+            break;
+        }
       }
       return base.Apply();
Index: branches/HiveHiveEngine/HeuristicLab.Operators/3.3/TargetOperationType.cs
===================================================================
--- branches/HiveHiveEngine/HeuristicLab.Operators/3.3/TargetOperationType.cs	(revision 7325)
+++ branches/HiveHiveEngine/HeuristicLab.Operators/3.3/TargetOperationType.cs	(revision 7325)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  [Item("TargetOperationType", "Represents a certain type of target parameter operation.")]
+  [StorableClass]
+  public class TargetOperationType : ValueTypeValue<TargetOperationTypes> {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Enum; }
+    }
+
+    [StorableConstructor]
+    protected TargetOperationType(bool deserializing) : base(deserializing) { }
+    protected TargetOperationType(TargetOperationType original, Cloner cloner) : base(original, cloner) { }
+    public TargetOperationType() : base() { }
+    public TargetOperationType(TargetOperationTypes type) : base(type) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TargetOperationType(this, cloner);
+    }
+  }
+}
Index: branches/HiveHiveEngine/HeuristicLab.Operators/3.3/TargetOperationTypes.cs
===================================================================
--- branches/HiveHiveEngine/HeuristicLab.Operators/3.3/TargetOperationTypes.cs	(revision 7325)
+++ branches/HiveHiveEngine/HeuristicLab.Operators/3.3/TargetOperationTypes.cs	(revision 7325)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Operators {
+  public enum TargetOperationTypes {
+    Set,
+    Sum,
+    Prod
+  }
+}