Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs	(revision 7327)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs	(revision 7328)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2601);
+      testPartition = new IntRange(20, 120);
     }
 
@@ -58,11 +58,6 @@
       DoubleRange range = new DoubleRange(-3, 3);
 
-      List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(range, 0.01);
-      List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
-      testData = RegressionBenchmark.GenerateAllCombinationsOfValuesInLists(testData);
-
       for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(2500, range));
-        dataList[i].AddRange(testData[i]);
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(5000, range));
       }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs	(revision 7327)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs	(revision 7328)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2601);
+      testPartition = new IntRange(20, 120);
     }
 
@@ -58,11 +58,6 @@
       DoubleRange range = new DoubleRange(-3, 3);
 
-      List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(range, 0.01);
-      List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
-      testData = RegressionBenchmark.GenerateAllCombinationsOfValuesInLists(testData);
-
       for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(2500, range));
-        dataList[i].AddRange(testData[i]);
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(5000, range));
       }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs	(revision 7327)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs	(revision 7328)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2601);
+      testPartition = new IntRange(20, 120);
     }
 
@@ -58,11 +58,6 @@
       DoubleRange range = new DoubleRange(-3, 3);
 
-      List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(range, 0.01);
-      List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
-      testData = RegressionBenchmark.GenerateAllCombinationsOfValuesInLists(testData);
-
       for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(2500, range));
-        dataList[i].AddRange(testData[i]);
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(5000, range));
       }
 
Index: /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs
===================================================================
--- /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs	(revision 7327)
+++ /branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs	(revision 7328)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(2500, 2601);
+      testPartition = new IntRange(20, 120);
     }
 
@@ -58,11 +58,6 @@
       DoubleRange range = new DoubleRange(-3, 3);
 
-      List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(range, 0.01);
-      List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
-      testData = RegressionBenchmark.GenerateAllCombinationsOfValuesInLists(testData);
-
       for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(2500, range));
-        dataList[i].AddRange(testData[i]);
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(5000, range));
       }
 