Index: /branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs	(revision 7328)
+++ /branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs	(revision 7329)
@@ -158,4 +158,5 @@
       VariableCreator islandVariableCreator = new VariableCreator();
       Placeholder islandAnalyzer1 = new Placeholder();
+      SubScopesRandomCreator subScopesRandomCreator = new SubScopesRandomCreator();
       Placeholder analyzer1 = new Placeholder();
       ResultsCollector resultsCollector1 = new ResultsCollector();
@@ -311,5 +312,6 @@
       uniformSubScopesProcessor0.Successor = analyzer1;
       islandVariableCreator.Successor = islandAnalyzer1;
-      islandAnalyzer1.Successor = null;
+      islandAnalyzer1.Successor = subScopesRandomCreator;
+      subScopesRandomCreator.Successor = null;
       analyzer1.Successor = resultsCollector1;
       resultsCollector1.Successor = uniformSubScopesProcessor1;
Index: /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 7328)
+++ /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 7329)
@@ -118,4 +118,5 @@
     <Compile Include="Assigner.cs" />
     <Compile Include="AlgorithmOperator.cs" />
+    <Compile Include="SubScopesRandomCreator.cs" />
     <Compile Include="TargetOperationType.cs" />
     <Compile Include="TargetOperationTypes.cs" />
Index: /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/SubScopesRandomCreator.cs
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/SubScopesRandomCreator.cs	(revision 7329)
+++ /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/SubScopesRandomCreator.cs	(revision 7329)
@@ -0,0 +1,68 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  [Item("SubScopesRandomCreator", "Creates pseudo random number generators for each subscope.")]
+  [StorableClass]
+  public sealed class SubScopesRandomCreator : SingleSuccessorOperator {
+    #region Parameter Properties
+    private LookupParameter<IRandom> GlobalRandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["GlobalRandom"]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    private IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private SubScopesRandomCreator(bool deserializing) : base(deserializing) { }
+    private SubScopesRandomCreator(SubScopesRandomCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public SubScopesRandomCreator()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope into which the random number generator is cloned."));
+      Parameters.Add(new LookupParameter<IRandom>("GlobalRandom", "A pseudo random number generator.", "Random"));
+      #endregion
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SubScopesRandomCreator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IRandom random = GlobalRandomParameter.ActualValue;
+      IRandom subScopesRandom = (IRandom)random.Clone();
+      subScopesRandom.Reset(random.Next());
+      CurrentScope.Variables.Add(new Variable("Random", "A pseudo random number generator.", subScopesRandom));
+      return base.Apply();
+    }
+  }
+}