Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionFifteen.cs	(revision 7336)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(20, 120);
+      testPartition = new IntRange(2500, 2600);
     }
 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionSixteen.cs	(revision 7336)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(20, 120);
+      testPartition = new IntRange(2500, 2600);
     }
 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionThirteen.cs	(revision 7336)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(20, 120);
+      testPartition = new IntRange(2500, 2600);
     }
 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Keijzer/KeijzerFunctionTwelve.cs	(revision 7336)
@@ -40,5 +40,5 @@
       inputVariables = new List<string>() { "X", "Y" };
       trainingPartition = new IntRange(0, 20);
-      testPartition = new IntRange(20, 120);
+      testPartition = new IntRange(2500, 2600);
     }
 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionEight.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionEight.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionEight.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(0, 4);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionEleven.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionEleven.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionEleven.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Z";
       inputVariables = new List<string>() { "X", "Y" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 100);
+      testPartition = new IntRange(500, 1000);
     }
 
@@ -55,6 +55,6 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(0, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionFive.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionFive.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionFive.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(-1, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionFour.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionFour.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionFour.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(-1, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionNine.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionNine.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionNine.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Z";
       inputVariables = new List<string>() { "X", "Y" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 100);
+      testPartition = new IntRange(500, 1000);
     }
 
@@ -55,6 +55,6 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(0, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionOne.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionOne.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionOne.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(-1, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionSeven.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionSeven.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionSeven.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(0, 2);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionSix.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionSix.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionSix.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(1, -1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTen.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTen.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTen.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Z";
       inputVariables = new List<string>() { "X", "Y" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 100);
+      testPartition = new IntRange(500, 1000);
     }
 
@@ -55,6 +55,6 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(0, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionThree.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionThree.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionThree.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(-1, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTwelve.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTwelve.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTwelve.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Z";
       inputVariables = new List<string>() { "X", "Y" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 100);
+      testPartition = new IntRange(500, 1000);
     }
 
@@ -55,6 +55,6 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(0, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTwo.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTwo.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Nguyen/NguyenFunctionTwo.cs	(revision 7336)
@@ -37,6 +37,6 @@
       targetVariable = "Y";
       inputVariables = new List<string>() { "X" };
-      trainingPartition = new IntRange(0, 250);
-      testPartition = new IntRange(250, 500);
+      trainingPartition = new IntRange(0, 20);
+      testPartition = new IntRange(250, 350);
     }
 
@@ -54,5 +54,5 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange range = new DoubleRange(-1, 1);
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(testPartition.End, range));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, range));
 
       return dataList;
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/KotanchekFunction.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/KotanchekFunction.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/KotanchekFunction.cs	(revision 7336)
@@ -38,5 +38,5 @@
       inputVariables = new List<string>() { "X1", "X2" };
       trainingPartition = new IntRange(0, 100);
-      testPartition = new IntRange(100, 2125);
+      testPartition = new IntRange(1000, 3025);
     }
 
@@ -55,7 +55,4 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange trainingRange = new DoubleRange(0.3, 4);
-      for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(TrainingPartition.End, trainingRange));
-      }
 
       List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(new DoubleRange(-0.2, 4.2), 0.1);
@@ -63,4 +60,5 @@
       testData = RegressionBenchmark.GenerateAllCombinationsOfValuesInLists(testData);
       for (int i = 0; i < InputVariable.Count; i++) {
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, trainingRange));
         dataList[i].AddRange(testData[i]);
       }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/RationalPolynomialThreeDimensional.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/RationalPolynomialThreeDimensional.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/RationalPolynomialThreeDimensional.cs	(revision 7336)
@@ -38,5 +38,5 @@
       inputVariables = new List<string>() { "X1", "X2", "X3" };
       trainingPartition = new IntRange(0, 300);
-      testPartition = new IntRange(300, 3000);
+      testPartition = new IntRange(1000, 3700);
     }
 
@@ -55,7 +55,8 @@
     protected override List<List<double>> GenerateInput() {
       List<List<double>> dataList = new List<List<double>>();
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(300, new DoubleRange(0.05, 2)));
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(300, new DoubleRange(1, 2)));
-      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(300, new DoubleRange(0.05, 2)));
+      int amountOfPoints = 1000;
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(amountOfPoints, new DoubleRange(0.05, 2)));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(amountOfPoints, new DoubleRange(1, 2)));
+      dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(amountOfPoints, new DoubleRange(0.05, 2)));
 
       List<List<double>> testData = new List<List<double>>() { 
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/RationalPolynomialTwoDimensional.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/RationalPolynomialTwoDimensional.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/RationalPolynomialTwoDimensional.cs	(revision 7336)
@@ -38,5 +38,5 @@
       inputVariables = new List<string>() { "X1", "X2" };
       trainingPartition = new IntRange(0, 50);
-      testPartition = new IntRange(50, 1207);
+      testPartition = new IntRange(1000, 2157);
     }
 
@@ -55,7 +55,4 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange trainingRange = new DoubleRange(0.05, 6.05);
-      for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(TrainingPartition.End, trainingRange));
-      }
 
       List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(new DoubleRange(-0.25, 6.35), 0.2);
@@ -64,4 +61,5 @@
       testData = RegressionBenchmark.GenerateAllCombinationsOfValuesInLists(testData);
       for (int i = 0; i < InputVariable.Count; i++) {
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(1000, trainingRange));
         dataList[i].AddRange(testData[i]);
       }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/SineCosineFunction.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/SineCosineFunction.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionBenchmarks/Vladislavleva/SineCosineFunction.cs	(revision 7336)
@@ -38,5 +38,5 @@
       inputVariables = new List<string>() { "X1", "X2" };
       trainingPartition = new IntRange(0, 30);
-      testPartition = new IntRange(30, 991);
+      testPartition = new IntRange(500, 1461);
     }
 
@@ -55,7 +55,4 @@
       List<List<double>> dataList = new List<List<double>>();
       DoubleRange trainingRange = new DoubleRange(0.1, 5.9);
-      for (int i = 0; i < InputVariable.Count; i++) {
-        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(30, trainingRange));
-      }
 
       List<double> oneVariableTestData = RegressionBenchmark.GenerateSteps(new DoubleRange(-0.05, 6.05), 0.02);
@@ -64,4 +61,5 @@
 
       for (int i = 0; i < InputVariable.Count; i++) {
+        dataList.Add(RegressionBenchmark.GenerateUniformDistributedValues(500, trainingRange));
         dataList[i].AddRange(testData[i]);
       }
Index: branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionGenerator/RegressionBenchmark.cs
===================================================================
--- branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionGenerator/RegressionBenchmark.cs	(revision 7328)
+++ branches/RegressionBenchmarks/HeuristicLab.Problems.DataAnalysis.Benchmarks/3.4/RegressionGenerator/RegressionBenchmark.cs	(revision 7336)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -62,5 +63,5 @@
 
     public static List<double> GenerateSteps(DoubleRange range, double stepWidth) {
-      return Enumerable.Range(0, (int)((range.End - range.Start) / stepWidth) + 1)
+      return Enumerable.Range(0, (int)Math.Round(((range.End - range.Start) / stepWidth) + 1))
                                       .Select(i => (range.Start + i * stepWidth))
                                       .ToList<double>();