Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views-3.4.csproj
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views-3.4.csproj	(revision 7337)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views-3.4.csproj	(revision 7338)
@@ -275,4 +275,9 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="SymbolicRegressionSolutionView.resx">
+      <DependentUpon>SymbolicRegressionSolutionView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs	(revision 7337)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs	(revision 7338)
@@ -36,7 +36,7 @@
       // 
       // 
-      // splitContainer.Panel1
+      // splitContainer.Panel2
       // 
-      this.splitContainer.Panel1.Controls.Add(this.btnSimplify);
+      this.splitContainer.Panel2.Controls.Add(this.btnSimplify);
       this.splitContainer.Size = new System.Drawing.Size(480, 275);
       this.splitContainer.SplitterDistance = 255;
@@ -68,6 +68,5 @@
       // btnSimplify
       // 
-      this.btnSimplify.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.btnSimplify.Location = new System.Drawing.Point(177, 4);
+      this.btnSimplify.Location = new System.Drawing.Point(3, 4);
       this.btnSimplify.Name = "btnSimplify";
       this.btnSimplify.Size = new System.Drawing.Size(75, 23);
Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 7337)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 7338)
@@ -366,4 +366,9 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Solution Views\RegressionSolutionView.resx">
+      <DependentUpon>RegressionSolutionView.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 7337)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 7338)
@@ -45,4 +45,6 @@
     /// </summary>
     private void InitializeComponent() {
+      this.btnImport = new System.Windows.Forms.Button();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -55,4 +57,8 @@
       // splitContainer
       // 
+      // 
+      // splitContainer.Panel1
+      // 
+      this.splitContainer.Panel1.Controls.Add(this.btnImport);
       // 
       // itemsGroupBox
@@ -67,4 +73,20 @@
       // 
       this.toolTip.SetToolTip(this.removeButton, "Remove");
+      // 
+      // btnImport
+      // 
+      this.btnImport.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.btnImport.Location = new System.Drawing.Point(172, 4);
+      this.btnImport.Name = "btnImport";
+      this.btnImport.Size = new System.Drawing.Size(75, 23);
+      this.btnImport.TabIndex = 7;
+      this.btnImport.Text = "Import";
+      this.btnImport.UseVisualStyleBackColor = true;
+      this.btnImport.Click += new System.EventHandler(this.btnImport_Click);
+      // 
+      // openFileDialog
+      // 
+      this.openFileDialog.Filter = "HL files|*.hl";
+      this.openFileDialog.Title = "Import ProblemData or Problem...";
       // 
       // RegressionSolutionView
@@ -84,4 +106,7 @@
 
     #endregion
+
+    private System.Windows.Forms.Button btnImport;
+    private System.Windows.Forms.OpenFileDialog openFileDialog;
   }
 }
Index: branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs
===================================================================
--- branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 7337)
+++ branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 7338)
@@ -20,7 +20,11 @@
 #endregion
 
+using System;
+using System.Collections.Generic;
 using System.Windows.Forms;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
@@ -50,4 +54,56 @@
     }
     #endregion
+
+    private void btnImport_Click(object sender, System.EventArgs e) {
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        object hlFile = null;
+        try {
+          hlFile = XmlParser.Deserialize(openFileDialog.FileName);
+        }
+        catch (Exception ex) {
+          ErrorHandling.ShowErrorDialog(this, ex);
+        }
+        IRegressionProblemData problemData = null;
+        if (hlFile != null && hlFile is RegressionProblemData) {
+          problemData = (RegressionProblemData)hlFile;
+        } else if (hlFile != null && hlFile is IRegressionProblem) {
+          problemData = ((IRegressionProblem)hlFile).ProblemData;
+        }
+        if (problemData != null) {
+          IList<string> missingVariables = new List<string>();
+          if (!problemData.TargetVariable.Equals(Content.ProblemData.TargetVariable))
+            missingVariables.Add(Content.ProblemData.TargetVariable);
+
+          //foreach (var item in Content.ProblemData.InputVariables.CheckedItems) {
+          //  if (!problemData.InputVariables.Contains(item.Value))
+          //    missingVariables.Add(item.Value.ToString());
+          //}
+
+          //easier solution will be created later
+          bool found;
+          foreach (var item in Content.ProblemData.InputVariables.CheckedItems) {
+            found = false;
+            foreach (var it in problemData.InputVariables) {
+              if (it.Value.Equals(item.Value.Value)) {
+                found = true;
+                break;
+              }
+            }
+            if (!found)
+              missingVariables.Add(item.Value.ToString());
+          }
+
+          if (missingVariables.Count != 0) {
+            string message = "";
+            foreach (var item in missingVariables) {
+              message += item + Environment.NewLine;
+            }
+            ErrorHandling.ShowErrorDialog(this, new Exception(message));
+          } else {
+            Content.ProblemData = problemData;
+          }
+        }
+      }
+    }
   }
 }