Index: trunk/tools/FxCop/HeuristicLab.FxCop.sln
===================================================================
--- trunk/tools/FxCop/HeuristicLab.FxCop.sln	(revision 7340)
+++ trunk/tools/FxCop/HeuristicLab.FxCop.sln	(revision 7340)
@@ -0,0 +1,20 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 11.00
+# Visual Studio 2010
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.FxCop", "HeuristicLab.FxCop\HeuristicLab.FxCop.csproj", "{FEE04F36-4C93-4B9E-BF22-D899ADFBD334}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Release|Any CPU = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{FEE04F36-4C93-4B9E-BF22-D899ADFBD334}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{FEE04F36-4C93-4B9E-BF22-D899ADFBD334}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{FEE04F36-4C93-4B9E-BF22-D899ADFBD334}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{FEE04F36-4C93-4B9E-BF22-D899ADFBD334}.Release|Any CPU.Build.0 = Release|Any CPU
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: trunk/tools/FxCop/HeuristicLab.FxCop/EnforceAfterDeserializationHookName.cs
===================================================================
--- trunk/tools/FxCop/HeuristicLab.FxCop/EnforceAfterDeserializationHookName.cs	(revision 7340)
+++ trunk/tools/FxCop/HeuristicLab.FxCop/EnforceAfterDeserializationHookName.cs	(revision 7340)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using Microsoft.FxCop.Sdk;
+
+namespace HeuristicLab.FxCop {
+  internal sealed class EnforceAfterDeserializationHookName : HeuristicLabFxCopRuleBase {
+    public EnforceAfterDeserializationHookName()
+      : base("EnforceAfterDeserializationHookName") { }
+
+    public override ProblemCollection Check(Member member) {
+      Method method = member as Method;
+      if (method == null) return null;
+
+      if (method.Attributes.Any(x => x.Type.FullName == "HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableHookAttribute")
+        && method.Name.Name != "AfterDeserialization") {
+        var resolution = GetResolution(method.FullName);
+        Problems.Add(new Problem(resolution));
+      }
+
+      return Problems;
+    }
+  }
+}
Index: trunk/tools/FxCop/HeuristicLab.FxCop/HeuristicLab.FxCop.csproj
===================================================================
--- trunk/tools/FxCop/HeuristicLab.FxCop/HeuristicLab.FxCop.csproj	(revision 7340)
+++ trunk/tools/FxCop/HeuristicLab.FxCop/HeuristicLab.FxCop.csproj	(revision 7340)
@@ -0,0 +1,64 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{FEE04F36-4C93-4B9E-BF22-D899ADFBD334}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.FxCop</RootNamespace>
+    <AssemblyName>HeuristicLab.FxCop</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="FxCopSdk">
+      <HintPath>$(CodeAnalysisPath)\FxCopSdk.dll</HintPath>
+    </Reference>
+    <Reference Include="Microsoft.Cci">
+      <HintPath>$(CodeAnalysisPath)\Microsoft.Cci.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="EnforceAfterDeserializationHookName.cs" />
+    <Compile Include="HeuristicLabFxCopRuleBase.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="RuleMetadata.xml" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: trunk/tools/FxCop/HeuristicLab.FxCop/HeuristicLabFxCopRuleBase.cs
===================================================================
--- trunk/tools/FxCop/HeuristicLab.FxCop/HeuristicLabFxCopRuleBase.cs	(revision 7340)
+++ trunk/tools/FxCop/HeuristicLab.FxCop/HeuristicLabFxCopRuleBase.cs	(revision 7340)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using Microsoft.FxCop.Sdk;
+
+namespace HeuristicLab.FxCop {
+
+  internal abstract class HeuristicLabFxCopRuleBase : BaseIntrospectionRule {
+    protected HeuristicLabFxCopRuleBase(string ruleName)
+      : base(ruleName, "HeuristicLab.FxCop.RuleMetadata", typeof(HeuristicLabFxCopRuleBase).Assembly) { }
+  }
+
+}
+
Index: trunk/tools/FxCop/HeuristicLab.FxCop/Properties/AssemblyInfo.cs
===================================================================
--- trunk/tools/FxCop/HeuristicLab.FxCop/Properties/AssemblyInfo.cs	(revision 7340)
+++ trunk/tools/FxCop/HeuristicLab.FxCop/Properties/AssemblyInfo.cs	(revision 7340)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.FxCop")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab.FxCop")]
+[assembly: AssemblyCopyright("Copyright ©  2012")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("d7c3c9f1-3073-4666-beb5-c0abe9a41f20")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: trunk/tools/FxCop/HeuristicLab.FxCop/RuleMetadata.xml
===================================================================
--- trunk/tools/FxCop/HeuristicLab.FxCop/RuleMetadata.xml	(revision 7340)
+++ trunk/tools/FxCop/HeuristicLab.FxCop/RuleMetadata.xml	(revision 7340)
@@ -0,0 +1,13 @@
+﻿<?xml version="1.0" encoding="utf-8" ?>
+<Rules FriendlyName="HeuristicLab 3.3 FxCop Rules">
+  <Rule TypeName="EnforceAfterDeserializationHookName" Category="HeuristicLab.Persistence" CheckId="HL0001">
+    <Name>Enforce AfterDeserialization as method name</Name>
+    <Description>Enforce the name AfterDeserialization for methods marked with the respective hook.</Description>
+    <Resolution>Method {0} is marked to act as an AfterDeserializationHook. It needs to be called AfterDeserialization.</Resolution>
+    <MessageLevel Certainty="100">Error</MessageLevel>
+    <FixCategories>Breaking</FixCategories>
+    <Url />
+    <Owner />
+    <Email />
+  </Rule>
+</Rules>